/*
 * Tfundecl.h
 * T routine declarations
 *
 */

#ifndef TFUNDECL_H
#define TFUNDECL_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "std.h"
#include "dvstd.h"
#include "dvGR.h"
#include "VOstd.h"
#include "dvtools.h"


/***
*** 
***/




/* T/Tdsl.c */
ADDRESS TdlForEachDataSource V_P_((DATASOURCELIST datasrclist,
	 TDLFOREACHDSFUNPTR fun,  ADDRESS argblock));
BOOLPARAM TdlOpenData V_P_((DATASOURCELIST datasrclist));
int TdlReadData V_P_((DATASOURCELIST datasrclist));
BOOLPARAM TdlCloseData V_P_((DATASOURCELIST datasrclist));
ADDRESS TdlForEachVar V_P_((DATASOURCELIST datasrclist,
	 TDLFOREACHDSVFUNPTR fun,  ADDRESS argblock));
BOOLPARAM TdlSave V_P_((DATASOURCELIST dsl,  char *filename,
	 int access_mode));
DATASOURCELIST TdlLoad V_P_((char *filename));
DATASOURCELIST TdlClone V_P_((DATASOURCELIST dsl));
BOOLPARAM TdlDeleteDataSource V_P_((DATASOURCELIST dsl,
	 DATASOURCE ds));
BOOLPARAM TdlAddDataSource V_P_((DATASOURCELIST dsl,  DATASOURCE ds,
	 DATASOURCE ds_reference));
int TdlDestroy V_P_((DATASOURCELIST dsl));
DATASOURCELIST TdlCreate V_P_((void));
DATASOURCE TdlGetNamedDataSource V_P_((DATASOURCELIST dsl,
	 char *name));
BOOLPARAM TdlValid V_P_((DATASOURCELIST dsl));
void TdlDummy V_P_((void));

/***
*** 
***/




/* T/Tdp.c */
ADDRESS TdpCreate V_P_((OBJECT screen,  VIEW view,  RECTANGLE *viewport,
	 RECTANGLE *window));
ADDRESS TdpCreateStretch V_P_((OBJECT screen,  VIEW view,
	 RECTANGLE *viewport,  RECTANGLE *window));
ADDRESS TdpCreateFixedScale V_P_((OBJECT screen,  VIEW view,
	 RECTANGLE *viewport,  RECTANGLE *window, BOOLPARAM initialStretch));
ADDRESS TdpSetupDraw V_P_((OBJECT screen,  VIEW view,
	 RECTANGLE *viewport,  RECTANGLE *window));
ADDRESS TdpSetupStretch V_P_((OBJECT screen,  VIEW view,
	 RECTANGLE *viewport,  RECTANGLE *window));
double TdpGetScale V_P_((DRAWPORT drawport));
OBJECT TdpGetScreen V_P_((DRAWPORT drawport));
OBJECT TdpGetVpObject V_P_((DRAWPORT drawport));
VIEW TdpGetView V_P_((DRAWPORT drawport));
RECTANGLE *TdpGetScreenVp V_P_((DRAWPORT drawport));
RECTANGLE *TdpGetViewport V_P_((DRAWPORT drawport));
RECTANGLE *TdpGetDrawingVp V_P_((DRAWPORT drawport));
RECTANGLE *TdpGetWindow V_P_((DRAWPORT drawport));
BOOLPARAM TdpIsDrawn V_P_((DRAWPORT drawport));
BOOLPARAM TdpDraw V_P_((DRAWPORT drawport));
BOOLPARAM TdpRedrawNext V_P_((DRAWPORT drawport));
BOOLPARAM TdpDrawNext V_P_((DRAWPORT drawport));
BOOLPARAM TdpDrawObject V_P_((DRAWPORT drawport,  OBJECT object));
BOOLPARAM TdpRedrawObject V_P_((DRAWPORT drawport,  OBJECT object));
BOOLPARAM TdpDrawNextObject V_P_((DRAWPORT drawport,  OBJECT object));
BOOLPARAM TdpErase V_P_((DRAWPORT drawport));
BOOLPARAM TdpEraseObject V_P_((DRAWPORT drawport,  OBJECT object));
ADDRESS TdpForEachDrawport V_P_((TDPTRAVERSEFUNPTR fun,  ADDRESS args));
void TdpDone V_P_((DRAWPORT drawport));
BOOLPARAM TdpDestroy V_P_((DRAWPORT drawport));
BOOLPARAM TdpFree V_P_((DRAWPORT dp));
BOOLPARAM TdpPan V_P_((DRAWPORT drawport, DV_POINT *center));
BOOLPARAM TdpZoom V_P_((DRAWPORT drawport, double scale));
BOOLPARAM TdpResize V_P_((DRAWPORT drawport,
	 RECTANGLE *virt_window));
BOOLPARAM TdpZoomTo V_P_((DRAWPORT drawport,  RECTANGLE *zoom_to));
OBJECT TdpGetXform V_P_((DRAWPORT drawport, int flag));
BOOLPARAM TdpFront V_P_((DRAWPORT drawport));
BOOLPARAM TdpBack V_P_((DRAWPORT drawport));
BOOLPARAM TdpRedraw V_P_((DRAWPORT drawport,  RECTANGLE *vp,
	 int erase_flag));
BOOLPARAM TdpWorldToScreen V_P_((DRAWPORT drawport,  DV_POINT *wcp,
	 DV_POINT *scp));
BOOLPARAM TdpScreenToWorld V_P_((DRAWPORT drawport,  DV_POINT *scp,
	 DV_POINT *wcp));
LONG TdpMaskPlanes V_P_((DRAWPORT drawport, LONG mask));
RECTANGLE **TdpObsvpGet V_P_((DRAWPORT drawport));
BOOLPARAM TdpSetRefreshFun V_P_((DRAWPORT drawport,
				 TDPREFRESHFUNPTR refresh_fun,
				 ADDRESS args,  LONG argsize));
BOOLPARAM TdpEraseRefresh V_P_((DRAWPORT drawport));

/***
*** 
***/




/* T/Tdr.c */
ADDRESS TdrForEachNamedObject V_P_((OBJECT drawing,
				    TDRFOREACHNAMEDOBJFUNPTR fcn,
				    ADDRESS argblock));
OBJECT TdrGetSelectedObject V_P_((OBJECT drawing,  OBJECT location,
	 int check_mode));
OBJECT TdrGetSelectedSubObject V_P_((OBJECT drawing,  OBJECT location,
	 int check_mode));
char *TdrGetObjectName V_P_((OBJECT drawing,  OBJECT object));
BOOLPARAM TdrNameObject V_P_((OBJECT drawing,  OBJECT object,
	 char *name));
OBJECT TobWasSelected V_P_((OBJECT object,  OBJECT location));
OBJECT TdrGetNamedObject V_P_((OBJECT drawing,  char *name));

/***
*** 
***/




/* T/Tds.c */
BOOLPARAM TdsOpenData V_P_((DATASOURCE datasrc));
BOOLPARAM TdsMoveDsVar V_P_((DATASOURCE ds,  DSVAR dsvar,
	 DSVAR dsvar_reference));
BOOLPARAM TdsReadData V_P_((DATASOURCE datasrc));
BOOLPARAM TdsCloseData V_P_((DATASOURCE datasrc));
ADDRESS TdsForEachVar V_P_((DATASOURCE datasrc,  TDSFOREACHVARFUNPTR fun,
	 ADDRESS argblock));
char *TdsGetName V_P_((DATASOURCE datasrc));
DATASOURCE TdsGetNextDataSource V_P_((DATASOURCE datasrc));
BOOLPARAM TdsMoveDataSource V_P_((DATASOURCE dstomove,
	 DATASOURCE dstoinsertbefore));
BOOLPARAM TdsDeleteDataSource V_P_((DATASOURCE datasrc));
BOOLPARAM TdsSave V_P_((DATASOURCE ds,  char *filename,
	 int access_mode));
DATASOURCE TdsLoad V_P_((char *filename));
DATASOURCE TdsClone V_P_((DATASOURCE ds));
DATASOURCE TdsCreate V_P_((void));
DATASOURCE TdsFdsCreate V_P_((char *fds_name));
DSVAR TdsCreateDsVar V_P_((DATASOURCE ds));
BOOLPARAM TdsDestroy V_P_((DATASOURCE ds));
BOOLPARAM TdsDeleteDsVar V_P_((DATASOURCE ds,  DSVAR dsvar));
BOOLPARAM TdsAddDsVar V_P_((DATASOURCE ds,  DSVAR dsvar,
	 DSVAR dsvar_reference));
void TdsSwitchDsVar V_P_((DATASOURCE src_ds,  DATASOURCE dst_ds,
	 DSVAR switch_dsv));
BOOLPARAM TdsAddListofDsVars V_P_((DATASOURCE ds,  DSVAR dsvar_list,
	 DSVAR dsvar_reference));
DSVAR TdsDeleteListofDsVars V_P_((DATASOURCE ds,  DSVAR dsvar,
	 int sublist_length));
BOOLPARAM TdsGetAttributes V_P_((DATASOURCE ds,  int *type,  int *format,
	 char **source));
BOOLPARAM TdsEditAttributes V_P_((DATASOURCE ds,  int type,  int format,
	 char *source));
DSVAR TdsGetNamedDsVar V_P_((DATASOURCE ds, char *name));
BOOLPARAM TdsSetAuxData V_P_((DATASOURCE ds,  ADDRESS data,
	 TDSFREEFUNPTR freefcn));
ADDRESS TdsGetAuxData V_P_((DATASOURCE ds));
char *TdsGetFdsName V_P_((DATASOURCE ds));
BOOLPARAM TdsSetFdsByName V_P_((DATASOURCE ds,  char *fds_name));
BOOLPARAM TdsGetFcnArg V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype,
	 int argindex,  int *typep,  ANYTYPE *valuep));
BOOLPARAM TdsSetFcnArg V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype,
	 int argindex,  int type,  ANYTYPE *valuep));
BOOLPARAM TdsClrFcnArg V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype,
	 int argindex));
BOOLPARAM TdsGetFcnArgCnt V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype,
	 int *def_arg_cntp,  int *opt_arg_cntp));
char *TdsGetFcnName V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype));
BOOLPARAM TdsSetFcnByName V_P_((DATASOURCE ds,  V_FDS_FCN_ENUM fcntype,
	 char *fcnname));
BOOLPARAM TdsValid V_P_((DATASOURCE ds));
void TdsDummy V_P_((void));

/* SccsId[]= @(#)Tdsvfuns.h    V1.6    2/10/95 */
/***
*** 
***/




/* T/Tdsv.c */
BOOLPARAM TdsvGetTypedValue V_P_((DSVAR dsvptr,  int valtype,
	 ADDRESS val,  int row,  int column));
BOOLPARAM TdsvGetValue V_P_((DSVAR dsvptr,  double *val,  int row,
	 int column));
BOOLPARAM TdsvReadData V_P_((DSVAR dsvar));
BOOLPARAM TdsvWriteData V_P_((DSVAR dsvar));
DATASOURCE TdsvGetDataSource V_P_((DSVAR dsvptr));
ADDRESS TdsvGetBuffer V_P_((DSVAR dsvptr));
BOOLPARAM TdsvSetValue V_P_((DSVAR dsvptr,  double val,  int row,
	 int column));
INT TdsvSetInitialValue V_P_((DSVAR dsvptr, double initial_value));
BOOLPARAM TdsvSetTypedValue V_P_((DSVAR dsvptr,  int valtype,
	 ADDRESS val,  int row,  int column));
char *TdsvGetName V_P_((DSVAR dsvptr));
int TdsvGetSize V_P_((DSVAR dsvptr,  int *rows,  int *columns));
int TdsvGetType V_P_((DSVAR dsvptr));
DSVAR TdsvCreate V_P_((void));
BOOLPARAM TdsvDestroy V_P_((DSVAR dsvar));
DSVAR TdsvClone V_P_((DSVAR dsvar));
BOOLPARAM TdsvGetAttributes V_P_((DSVAR dsvar,  char **name,  int *type,
	 int *rows,  int *columns,  char *delimiter));
BOOLPARAM TdsvEditAttributes V_P_((DSVAR dsvar,  char *name,  int type,
	 int rows,  int columns,  int delimiter));
BOOLPARAM TdsvAttachVdp V_P_((DSVAR dsvar, ADDRESS vdp));
BOOLPARAM TdsvDetachVdp V_P_((DSVAR dsvar, ADDRESS vdp));
DSVAR TdsvCloneSublist V_P_((DSVAR dsvar,  int sublist_length));
BOOLPARAM TdsvSaveList V_P_((DSVAR dsvar,  char *filename,
	 int access_mode));
DSVAR TdsvLoadList V_P_((char *filename));
int TdsvGetListLength V_P_((DSVAR dsvar));
BOOLPARAM TdsvDestroyList V_P_((DSVAR dsvar));
int TdsvGetGlobalFlag V_P_((DSVAR dsvar));
BOOLPARAM TdsvSetGlobalFlag V_P_((DSVAR dsvar, int flag));
ADDRESS TdsvForEachVdp V_P_((DSVAR dsvar,  TDSVFOREACHVDPFUNPTR fun,
			     ADDRESS argblock));
ADDRESS TdsvForEachRef V_P_((DSVAR dsvar,  TDSVFOREACHREFFUNPTR fun,
			     ADDRESS argblock));
BOOLPARAM TdsvSetAuxData V_P_((DSVAR dsvar,  ADDRESS data,
			       TDSVFREEFUNPTR freefun));
ADDRESS TdsvGetAuxData V_P_((DSVAR dsvar));
BOOLPARAM TdsvGetFcnArg V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype,
	 int argindex,  int *typep,  ANYTYPE *valuep));
BOOLPARAM TdsvSetFcnArg V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype,
	 int argindex,  int type,  ANYTYPE *valuep));
BOOLPARAM TdsvClrFcnArg V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype,
	 int argindex));
BOOLPARAM TdsvGetFcnArgCnt V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype,
	 int *def_arg_cntp,  int *opt_arg_cntp));
char *TdsvGetFcnName V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype));
BOOLPARAM TdsvSetFcnByName V_P_((DSVAR dsv,  V_FDS_FCN_ENUM fcntype,
	 char *fcnname));
BOOLPARAM TdsvValid V_P_((DSVAR dsv));
void TdsvDummy V_P_((void));

/***
*** 
***/




/* T/T.c */
BOOLPARAM TInit V_P_((char *filepath, char *dspformsfile));
BOOLPARAM TTerminate V_P_((void));

/***
*** 
***/




/* T/Tlo.c */
OBJECT TPoll V_P_((int poll_type));
OBJECT TloPoll V_P_((int poll_type));
DRAWPORT TGetSelectedDrawport V_P_((OBJECT location));
DRAWPORT TloGetSelectedDrawport V_P_((OBJECT location));
char *TGetSelectedObjectName V_P_((OBJECT location));
char *TloGetSelectedObjectName V_P_((OBJECT location));
char *TloGetSelectedSubObjectName V_P_((OBJECT location));
OBJECT TGetSelectedObject V_P_((OBJECT location));
OBJECT TloGetSelectedObject V_P_((OBJECT location));
OBJECT TloGetSelectedSubObject V_P_((OBJECT location));
BOOLPARAM TloSetup V_P_((OBJECT lo,  int key,  DV_POINT *spt,  OBJECT screen,
	 DRAWPORT dp));
BOOLPARAM TloWinEventSetup V_P_((OBJECT lo,  WINEVENT *we,  OBJECT screen,
	 DRAWPORT dp));

/***
*** 
***/




/* T/Tfcn.c */
LONG TfcnSetParams V_P_((ADDRESS ds_or_dsvar,  ADDRESS data,
	 void (*freefcn)()));
ADDRESS TfcnGetParams V_P_((ADDRESS ds_or_dsvar));

/* T/Tfds.c */
LONG TfdsSetParams V_P_((ADDRESS ds_or_dsvar,  ADDRESS data,
	 void (*freefcn)()));
ADDRESS TfdsGetParams V_P_((ADDRESS ds_or_dsvar));

/* T/Tutils.c */
void bad_checkf V_P_((char *fcname, char *errmsg));

/***
*** 
***/




/* T/Tobtrvrse.c */
ADDRESS TobForEachVdp V_P_((OBJECT object, TOBFOREACHVDPFUNPTR fun,
	 ADDRESS args));
ADDRESS TobForEachTopVdp V_P_((OBJECT object, TOBFOREACHVDPFUNPTR fun ,
	 ADDRESS args));
ADDRESS TobForEachSubobject V_P_((OBJECT object,
				  TOBFOREACHSUBOBJFUNPTR fun,
				  ADDRESS args));

/***
*** 
***/




/* T/Tproto.c */
void TprotoRun V_P_((OBJECT screen,  char *top_view,
	 DRAWPORT_ATTRIBUTES *dp_atts));
ADDRESS TprotoInit V_P_((OBJECT screen,  char *top_view,
	 DRAWPORT_ATTRIBUTES *dp_atts));
int TprotoHandleInput V_P_((ADDRESS proto_env,  OBJECT location));
void TprotoUpdate V_P_((ADDRESS proto_env));
void TprotoCleanup V_P_((ADDRESS proto_env));
void TprotoReset V_P_((ADDRESS proto_env));
void TprotoRedraw V_P_((ADDRESS proto_env));

/***
*** 
***/




/* T/Tsc.c */
OBJECT TscOpen V_P_((char *device, char *lutfile));
OBJECT TscOpenSet V_P_((char *device, char *lutfile, ...));
INT TscOpenError V_P_((void));
BOOLPARAM TscClose V_P_((OBJECT screen));
OBJECT TscOpenWindow V_P_((char *device,  LONG windowid,
	 char *lutfile));
OBJECT TscOpenRemoteWindow V_P_((char *device,  LONG display,
	 LONG windowid,  char *lutfile));
BOOLPARAM TscCloseCurrentScreen V_P_((void));
BOOLPARAM TscErase V_P_((OBJECT screen));
BOOLPARAM TscDrawBackground V_P_((OBJECT screen,  RECTANGLE *svp));
BOOLPARAM TscDraw V_P_((OBJECT screen, RECTANGLE *svp));
BOOLPARAM TscRedraw V_P_((OBJECT screen, RECTANGLE *svp));
BOOLPARAM TscReset V_P_((OBJECT screen));
OBJECT TscSetCurrentScreen V_P_((OBJECT screen));
BOOLPARAM TscFlushCurrentScreen V_P_((void));
BOOLPARAM TscFlush V_P_((OBJECT screen));
DRAWPORT TscFindDrawport V_P_((OBJECT screen, DV_POINT *spt));
OBJECT TscDefForecolor V_P_((OBJECT screen, OBJECT color));
OBJECT TscDefBackcolor V_P_((OBJECT screen, OBJECT color));
OBJECT TOpenScreen V_P_((char *device, char *lutfile));
BOOLPARAM TCloseScreen V_P_((void));
OBJECT TActiveScreen V_P_((OBJECT screen));
void TFlushScreen V_P_((void));

#ifdef WINNT
 void TscPrintStart V_P_((OBJECT screen, ADDRESS pr_struct));
 void TscPrintEnd V_P_((OBJECT screen));
 ADDRESS TscPrintSet V_P_((int start, ...));
#endif
/***
*** 
***/




/* T/Tvd.c */
DSVAR TvdGetDataSourceVariable V_P_((ADDRESS vdp));
DSVAR TvdPutDataSourceVariable V_P_((ADDRESS vdp,
	 DSVAR newdsvarptr));
ADDRESS TvdPutBuffer V_P_((ADDRESS vdp,  ADDRESS newbuffer));

/***
*** 
***/




/* T/Tvi.c */
VIEW TviCreate V_P_((void));
VIEW TviCreateFromDrawing V_P_((OBJECT drawing));
VIEW TviClone V_P_((VIEW view));
VIEW TviLoad V_P_((char *filename));
VIEW TviMemLoad V_P_((char *bufferp, int size));
VIEW TviStreamLoad V_P_((OBJECT stream));
BOOLPARAM TviSave V_P_((VIEW view, char *filename));
BOOLPARAM TviMemSave V_P_((VIEW view,  char **bufferpp,  int *sizep));
BOOLPARAM TviStreamSave V_P_((VIEW view, OBJECT stream));
BOOLPARAM TviASCIISave V_P_((VIEW view, char *filename));
BOOLPARAM TviASCIIMemSave V_P_((VIEW view,  char **bufferpp,
	 int *sizep));
BOOLPARAM TviDestroy V_P_((VIEW view));
OBJECT TviGetDrawing V_P_((VIEW view));
DATASOURCELIST TviGetDataSourceList V_P_((VIEW view));
int TviMergeDrawing V_P_((VIEW view, OBJECT drawing));
int TviExciseDrawing V_P_((VIEW view, OBJECT drawing));
DATASOURCELIST TviPutDataSourceList V_P_((VIEW view,
	 DATASOURCELIST dsl));
OBJECT TviPutDrawing V_P_((VIEW view, OBJECT drawing));
BOOLPARAM TviFileSave V_P_((VIEW view,  FILE *file_pointer,
	 int access_mode));
VIEW TviFileLoad V_P_((FILE *file_pointer));
char *TviGetComment V_P_((VIEW view));
void TviPutComment V_P_((VIEW view, char *comment));
BOOLPARAM TviOpenData V_P_((VIEW view));
BOOLPARAM TviReadData V_P_((VIEW view));
BOOLPARAM TviCloseData V_P_((VIEW view));
ADDRESS TviForEachDataSource V_P_((VIEW view,  ADDRFUNPTR fun,
	 ADDRESS argblock));
ADDRESS TviForEachVar V_P_((VIEW view,  ADDRFUNPTR fun,
	 ADDRESS argblock));
OBJECT TviUpdateDynDq V_P_((VIEW view, BOOLPARAM rebuild));
BOOLPARAM TviValid V_P_((VIEW view));

/* T/TviDynCnvt.c */
BOOLPARAM TviTestDynamics V_P_((VIEW view));
void TviConvertDynamics V_P_((VIEW view));

/* T/TviMrgdss.c */
BOOLPARAM TviMergeAddDataSources V_P_((VIEW view,
	 DATASOURCELIST master_dsl,  int matchflag));
DATASOURCELIST TviMergeDataSources V_P_((VIEW view,
	 DATASOURCELIST master_dsl,  int matchflag));
BOOLPARAM TdsMerge V_P_((DATASOURCE ds1,  DATASOURCE ds2,
	 int matchflag));

/* T/Tvishrdess.c */
DATASOURCELIST TviShareDataSources V_P_((VIEW view,
	 DATASOURCELIST masterdsl,  int addflag));


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* TFUNDECL_H */
